"""Go from Debian apt-rdepends output to JSON for a D3.js chart."""

class AptRdepends2JSON:
    """Convert Debian apt-rdepends output to JSON for a D3.js chart.

    In its man page, we read that apt-rdepends "performs recursive dependency
    listings similar to apt-cache". For instance, in the following snippet
    apt-rdepends has printed out the recursive dependencies for the two Debian
    packages "tar" and "libustr-1.0-1":

    tar
      PreDepends: libacl1 (>= 2.2.51-8)
      PreDepends: libc6 (>= 2.17)
      PreDepends: libselinux1 (>= 1.32)
    libustr-1.0-1
      Depends: libc6 (>= 2.4)
      PreDepends: multiarch-support

    Based on this snippet, we can then produce the following JSON for the
    D3.js chart:

    [
        {
            "imports": [
                "libacl1",
                "libc6",
                "libselinux1"
            ],
            "name": "tar"
        },
        {
            "imports": [
                "libc6",
                "multiarch-support"
            ],
            "name": "libustr-1.0-1"
        }
    ]
    """

    def __init__(self, aptrdepends_output, d3_json):
        """We set the following attributes:

        1. aptrdepends_output. The name of a file generated by something like...

        apt-rdepends aptitude > aptrdepends_output

        2. d3_json. The name of some JSON file that we will generate based on
        the contents of aptrdepends_output file.

        3. package_list. json.dump generates d3_json file by serializing the
        package_list list.
        """

        self.aptrdepends_output = aptrdepends_output
        self.d3_json = d3_json
        self.package_list = []

    def trim_dependency_line(self, my_string):
        """Remove leading and trailing characters that apt-rdepends inserts
        into the my_string argument.

        apt-rdepends specifies "Depends", "Pre-Depends", "strictly earlier",
        "exactly equal", etc relations between packages.

        For now, we're only interested in package names...

        >>> my_object = AptRdepends2JSON('apt-rdepends_aptitude',\
'apt-rdepends_aptitude.json')
        >>> f = open(my_object.aptrdepends_output)
        >>> lines = f.readlines()
        >>> print(lines[1].rstrip('\\n'))
          Depends: aptitude-common (= 0.8.11-7)
        >>> my_package_name = my_object.trim_dependency_line(lines[1])
        >>> print(my_package_name)
        aptitude-common
        >>> print(lines[43].rstrip('\\n'))
          PreDepends: libc6 (>= 2.28)
        >>> my_package_name = my_object.trim_dependency_line(lines[43])
        >>> print(my_package_name)
        libc6
        """

        trim_dependency_line_regex = re.compile('^\\s+\\S*Depends\\S\\s(\\S+)')
        my_match = trim_dependency_line_regex.match(my_string)
        return my_match.group(1)

    def check_for_dependency_lines(self, my_string):
        """Return True if my_string argument matches ^\\s+\\S*Depends regex.

        Among other things, in the following snippet apt-rdepends is saying
        that the recursive dependencies of libgcc1 are gcc-4.9-base, libc6, and
        multiarch-support...

        libgcc1
          Depends: gcc-4.9-base (= 4.9.0-7)
          Depends: libc6 (>= 2.14)
          PreDepends: multiarch-support

        >>> my_object = AptRdepends2JSON('apt-rdepends_aptitude',\
'apt-rdepends_aptitude.json')
        >>> f = open(my_object.aptrdepends_output)
        >>> lines = f.readlines()
        >>> print(lines[0].rstrip('\\n'))
        aptitude
        >>> my_object.check_for_dependency_lines(lines[0]) == None
        True
        >>> print(lines[1].rstrip('\\n'))
          Depends: aptitude-common (= 0.8.11-7)
        >>> bool(my_object.check_for_dependency_lines(lines[1])) == True
        True
        >>> print(lines[43].rstrip('\\n'))
          PreDepends: libc6 (>= 2.28)
        >>> bool(my_object.check_for_dependency_lines(lines[21])) == True
        True
        """

        this_is_a_dependency_line = re.compile('^\\s+\\S*Depends')
        return this_is_a_dependency_line.match(my_string)

    def read_aptrdepends_output(self):
        """Loop over lines of self.aptrdepends_output file, and construct
        self.d3_json list for json.dump serialization.

        This method takes apt-rdepends idiosyncracies into account. We're doing
        the following...

        1. self.d3_json list was initialized in __init__

        2. We loop over every line in self.aptrdepends_output file

        3. If line matches ^\\s+\\S*Depends regex, do the following...

        3A. Chop off extraneous "  (Pre)Depends: " substring

        3B. Chop off extraneous " (...something...) " substring

        3C. Append resulting string to imports list of current dictionary in
        loop

        4. If line does not match ^\\s+\\S*Depends regex, append new dictionary
        to self.d3_json. New dictionary is initialized like so...
        {'name':current_line_in_loop,'imports':[]}

        >>> my_aptrdepends = 'apt-rdepends_aptitude'
        >>> my_json = 'apt-rdepends_aptitude.json'
        >>> my_object = AptRdepends2JSON(my_aptrdepends, my_json)
        >>> my_object.read_aptrdepends_output()
        >>> print(my_object.package_list['children'][0])
        {'name': 'aptitude', 'imports': ['aptitude-common', 'libapt-pkg5.0', 'libboost-iostreams1.67.0', 'libboost-system1.67.0', 'libc6', 'libcwidget3v5', 'libgcc1', 'libncursesw6', 'libsigc++-2.0-0v5', 'libsqlite3-0', 'libstdc++6', 'libtinfo6', 'libxapian30']}
        """

        aptrdepends_file = open(self.aptrdepends_output, 'r')

        for rdepends_line in aptrdepends_file:

            if self.check_for_dependency_lines(rdepends_line):

                dependency = self.trim_dependency_line(rdepends_line)
                self.package_list[-1]['imports'].append(dependency)

            else:

                chomp = rdepends_line.rstrip('\n')
                self.package_list.append({'name':chomp, 'imports':[]})

        self.package_list = {'name': 'recursive_aptitude_dependencies',\
            'children': self.package_list}
        json_file = open(self.d3_json, 'w')
        json.dump(self.package_list, json_file, indent=4)
        json_file.close()

if __name__ == "__main__":
    import re
    import json

    import doctest
    doctest.testmod()
